#include "editor.h"

Edge *find_edge (float x, float y, int tolerance)
{
	list<Edge *>::iterator it;
	for (it = edges.begin(); it != edges.end(); it++) {
		if (x < (*it)->v1->x - tolerance && x < (*it)->v2->x - tolerance) continue;
		if (x > (*it)->v1->x + tolerance && x > (*it)->v2->x + tolerance) continue;
		if (y < (*it)->v1->y - tolerance && y < (*it)->v2->y - tolerance) continue;
		if (y > (*it)->v1->y + tolerance && y > (*it)->v2->y + tolerance) continue;

		float nx = (*it)->v1->y - (*it)->v2->y;
		float ny = (*it)->v2->x - (*it)->v1->x;
		float len = nx*nx+ny*ny;
		if (len < 0.01) continue;

		nx /= sqrt(len);
		ny /= sqrt(len);

		float dx = x - (*it)->v1->x;
		float dy = y - (*it)->v1->y;

		float dist = nx*dx + ny*dy;
		if (ABS(dist) < tolerance) return *it;
	}
	return NULL;
}

Edge *delete_edge (Edge *edge)
{
	list<Edge *>::iterator it;
	for (it = edges.begin(); it != edges.end(); it++)
		if ((*it) == edge) {
			edges.erase (it);
			break;
		}
	delete edge;
	return edge;
}

