// the enemy objects

#ifndef __ENEMY_H__
#define __ENEMY_H__


#include "thinglist.h"



// the enemy class
class Enemy : public Thing
{
public:
    Enemy(double x, double y, int type, int id, int targets[], float rocket_gravity);
	
	// update and render handlers
	bool update();
	void render(BITMAP *bmp);

    BITMAP* mBmp;

	const char *mName;

	class PlayerPanel *mPanel;

    Vector mTL, mBR;            // bounding box

    int mHealth;                // TODO: maybe get these from the level editor??
    int mOrigHealth;

	float mRocketGravity;

    float mHealthDisplayPercent;

    int mID;
    vector<int> mTargets;

    bool mFireThisFrame;
};



// global list of all enemies
extern ThingList<Enemy> enemies;




#endif		// __ENEMY_H__


