#include "flower.h"

Flower::Flower (float radius, float outer_radius, float inner_radius, int petals, int out_r, int out_g, int out_b, int in_r, int in_g, int in_b)
{
	mCentre = radius + outer_radius;

	for (int i = 0; i < mBrightnessLevels; i++) {
		mBmp[i] = create_bitmap ((int)(mCentre*2), (int)(mCentre*2));
		clear(mBmp[i]);

		int out_c = makecol (out_r * i / mBrightnessLevels, out_g * i / mBrightnessLevels, out_b * i / mBrightnessLevels);
		int in_c = makecol (in_r * i / mBrightnessLevels, in_g * i / mBrightnessLevels, in_b * i / mBrightnessLevels);

		for (int petal = 0; petal < petals; petal++)
			circlefill (mBmp[i], mCentre + radius * sin (2 * M_PI * petal / petals), mCentre + radius * cos (2 * M_PI * petal / petals), outer_radius, out_c);

		circlefill (mBmp[i], mCentre, mCentre, radius, out_c);
		circlefill (mBmp[i], mCentre, mCentre, inner_radius, in_c);
	}
}

