#include "gameplay.h"
#include "game.h"
#include "enemy.h"
#include "highscores.h"
#include "sound.h"

static int next_fire_count;
static int time_between_firing;
float gravity_multiplier;

static const int min_time_between_firing = 70;
static const float max_gravity_multiplier = 10;

bool game_over;
static int gameover_grace;


void init_gameplay()
{
    next_fire_count = 70 * 5;
    time_between_firing = 70 * 5;
    gravity_multiplier = 1;
    game_over = false;
    gameover_grace = 70 * 3;
}

bool update_gameplay()
{
    game_over = true;

    next_fire_count--;

    vector<Enemy*> aggressors;

    ThingList<Enemy>::iterator it = enemies.begin();
    while(it != enemies.end()) {
        Enemy& enemy = *it;

        enemy.mFireThisFrame = false;

        if(!enemy.mDead) {
            vector<int>::iterator idit = enemy.mTargets.begin();
            while(idit != enemy.mTargets.end()) {
                
                ThingList<Enemy>::iterator tit = enemies.begin();
                while(tit != enemies.end()) {
                    if(tit->mID == *idit) {
                        game_over = false;
                        aggressors.push_back(&enemy);
                    }
                    tit++;
                }
                idit++;
            }
        }

        it++;
    }

    if(!game_over) {

        if(next_fire_count <= 0) {
            next_fire_count = time_between_firing - 35 + (rand() % 70);

            int which_to_fire = rand() % aggressors.size();

            aggressors[which_to_fire]->mFireThisFrame = true;
        }

        if(game_time % (70 * 10) == 0) {
            time_between_firing = MAX(min_time_between_firing, time_between_firing - 10);

            if(time_between_firing <= min_time_between_firing) {
                gravity_multiplier = MIN(max_gravity_multiplier, gravity_multiplier + 0.1);
            }
        }

    }
    else {
        gameover_grace--;
        if(gameover_grace <= 0) {
            if ((key[KEY_RCONTROL] || key[KEY_LCONTROL] || key[KEY_SPACE] || key[KEY_ENTER])) {
				menu_click(true);
                do_highscores();
                return false;
            }

        }
    }

    return true;
}
